<template>
  <div>
    <ul class="ulMenu">
      <menu class="returnMenu">
        <li class="liReturnMenu">
          <!-- <a href='#'> -->
          <a v-on:click="returnToHome()">
            <i><font-awesome-icon :icon="['fas', 'arrow-left']" size="1x" /></i>
            <br />
            <span>Home</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="connect()">
            <i><font-awesome-icon :icon="['fas', 'plug']" size="1x" /></i>
            <br />
            <span>Conectar</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="sendLuaScript()">
            <i>
              <font-awesome-icon :icon="['fas', 'paper-plane']" size="1x" />
            </i>
            <br />
            <span>Programar</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="magicCodeGenerate()">
            <i><font-awesome-icon :icon="['fas', 'wand-magic-sparkles']" size="1x" /></i>
            <br />
            <span>Magic</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="saveCode()">
            <i><font-awesome-icon :icon="['fas', 'save']" size="1x" /></i>
            <br />
            <span>Guardar</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="undo()">
            <i><font-awesome-icon :icon="['fas', 'undo']" size="1x" /></i>
            <br />
            <span>&nbsp;&nbsp;&nbsp;Atrás&nbsp;&nbsp;&nbsp;</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="redo()">
            <i><font-awesome-icon :icon="['fas', 'redo']" size="1x" /></i>
            <br />
            <span>Adelante</span>
          </a>
        </li>
      </menu>
    </ul>
    <div>
      <ConnectModal
        @closeConnecModal="closeConnecModal"
        :trigger="triggerConnectModal"
      ></ConnectModal>
    </div>
  </div>
  <!-- MODAL POPUP -->
</template>

<script lang="ts">
/**
 * los ajustes javascript son propios
 * @author Johnny Cubides
 */

import { defineComponent, ref } from "vue";
import * as Blockly from "@johnnycubides/blockly-catalejo/blockly";

import {
  luna8266,
  TypeEditor,
  getCodeLuaFromBlockly,
  StatusTask,
  toastMsg,
  sleep,
} from "../../../host/index";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { library } from "@fortawesome/fontawesome-svg-core";
import {
  faArrowLeft,
  faPlug,
  faSave,
  faUndo,
  faRedo,
  faPlane,
} from "@fortawesome/free-solid-svg-icons";
library.add(faArrowLeft, faPlug, faSave, faUndo, faRedo, faPlane);

// -- IMPORT MODALS COMPONENTS --
import ConnectModal from "./luna8266FocusMenuModals/ConnectModal.vue";

export default defineComponent({
  components: {
    "font-awesome-icon": FontAwesomeIcon,
    ConnectModal,
  },

  props: ["parentWorkspace", "editorSelected", "codeFromCodemirror"],
  emits: ["savePrj", "magicCodeEmit"],
  setup(props, context) {
    const triggerConnectModal = ref(false);

    const returnToHome = (): void => {
      try {
        // Android.returnToHome();
        window.open("/dist/index.html", "_blank");
      } catch (Error) {
        console.log("Android.saveProject() failed", Error);
      }
    };

    const connect = () => {
      triggerConnectModal.value = true;
    };

    const closeConnecModal = () => {
      triggerConnectModal.value = false;
    };

    const sendLuaScript = async () => {
      let code = "";
      if (props.editorSelected == TypeEditor.Blockly) {
        code = await getCodeLuaFromBlockly(props.parentWorkspace);
      } else if (props.editorSelected == TypeEditor.Codemirror) {
        // console.log("crear función para extraer lua desde codemirror"); // TODO
        code = props.codeFromCodemirror.value;
      }

      luna8266.saveCodeInLuna8266(code);

      let statusConnectWithLuna = StatusTask.INPROCESS;
      const attempts = 4;
      let count = 0;
      while (
        statusConnectWithLuna == StatusTask.INPROCESS &&
        count < attempts
      ) {
        statusConnectWithLuna = luna8266.getStatusConnectLuna();
        if (statusConnectWithLuna == StatusTask.SUCCESS) {
          toastMsg({
            data: "Oprima el botón RST en la tarjeta para iniciar el programa enviado.",
            type: "info",
            time: 8000,
          });
        } else if (statusConnectWithLuna == StatusTask.ERROR) {
          toastMsg({
            data: "No fue posible establecer conexion con la tarjeta",
            type: "error",
            time: 5000,
          });
        } else if (statusConnectWithLuna == StatusTask.INPROCESS) {
          toastMsg({ data: "Tarea en proceso.", type: "warning" });
          await sleep(2000);
          count++;
        }
      }
      if (count == attempts) {
        luna8266.stopTestConnectLuna8266();
        statusConnectWithLuna = StatusTask.ERROR;
        toastMsg({
          data: "Intentos de conexión con la tarjeta terminados sin éxito.",
          type: "error",
          time: 5000,
        });
      }
    };

    let codeToggle = false;
    const magicCodeGenerate = async () => {
      codeToggle = !codeToggle;
      const ret = 0; // TODO, crear validador
      context.emit("magicCodeEmit", {
        code: await getCodeLuaFromBlockly(props.parentWorkspace),
        check: codeToggle,
      });
      toastMsg({
        data:
          ret == 0
            ? "Generando código desde Blockly y pegando en el editor de texto"
            : "No fue posible generar código",
        type: ret == 0 ? "info" : "warning",
        time: 3000,
      });
    };

    const saveCode = (): void => {
      /*try {
        Android.saveProject(getCodeLuaFromBlockly(), getXMLBlockly())
      } catch (Error) {
        console.log("Android.saveProject() failed", Error)
      }*/
      context.emit("savePrj");
    };

    const getXMLBlockly = (): string => {
      const xml = Blockly.Xml.workspaceToDom(props.parentWorkspace);
      return Blockly.Xml.domToText(xml);
    };

    /*const getCodeLuaFromBlockly = async (): string => {
      // luaGenerator.INFINITE_LOOP_TRAP = null // eslint-disable-line
      return await luaGenerator.workspaceToCode(props.parentWorkspace) // eslint-disable-line
    };*/

    const undo = (): void => {
      props.parentWorkspace.undo(false);
    };

    const redo = (): void => {
      props.parentWorkspace.undo(true);
    };

    return {
      // Methods
      returnToHome,
      sendLuaScript,
      saveCode,
      magicCodeGenerate,
      getXMLBlockly,
      getCodeLuaFromBlockly,
      undo,
      redo,
      connect,
      // triggers modals
      triggerConnectModal,
      // var modals
      // function modals
      closeConnecModal,
    };
  },
});
</script>

<style scoped>
div {
  /* TODO STYLE */
  background-color: #131516;
  /* background-image: url("https://images.unsplash.com/photo-1564500617448-e541b1df7cee?ixlib=rb-1.2.1&auto=format&fit=crop&w=1350&q=80");*/
  /* background-image: url("../assets/FocusMenu/photo-1564500617448-e541b1df7cee.webp?ixlib=rb-1.2.1&auto=format&fit=crop&w=1350&q=80");*/
  /* background: url(../assets/FocusMenu/banner_moon1.jpg); */
  background-size : cover;
  position: relative;
  padding: 0px 0px 0px 0px;
  top: 0px;
  margin: 0px 0px 0px 0px;
}

.ulMenu {
  position: relative;
  padding: 0px 0px 0px 0px;
  top: 0px;
  margin: 0px 0px 0px 0px;
  /* margin-left: -40px;*/
  width  : auto;
}

.liReturnMenu {
  list-style-type : none;
  /* TODO STYLE */
  background      : linear-gradient(rgba(220,220,255,0) 85%, rgba(255,255,255,0) 100%);
  text-align: center;
  /*display: inline-block;*/
  float   : left; /* left, right */
  cursor  : pointer;
  padding : 3px 10px;
  border-top    : 2px solid rgba(200,200,255,0.0);
  border-bottom : 2px solid rgba(50,50,50,0.0);
  padding: 2px 2px;
  margin: 0px 0px 0px 0px;
}

.returnMenu {
  position: fixed;
  padding: 0px 0px 0px 0px;
  left: 0px;
  margin: 0px 0px 0px 0px;
  border-radius : 3px;
}

.listMenu {
  position: fixed;
  padding: 0px 0px 0px 0px;
  right: 0px;
  margin: 0px 0px 0px 0px;
  border-radius : 3px;
  /*height: 200px; tamaño menu*/
}

.listMenu:after , .listMenu:before {
  display : block;
  content : " ";
}

.listMenu:after {
  clear : both;
}

li {
  list-style-type : none;
  /* TODO STYLE */
  background      : linear-gradient(rgba(220,220,255,0.1) 85%, rgba(255,255,255,0.5) 100%);
  text-align: center;
  /*display: inline-block;*/
  float   : left; /* left, right */
  cursor  : pointer;
  padding : 3px 10px;
  border-top    : 2px solid rgba(200,200,255,0.5);
  border-bottom : 2px solid rgba(50,50,50,0.4);
  padding: 2px 2px;
  margin: 0px 0px 0px 0px;
}

li:first-child {
  border-radius : 5px 0 0 5px;
}

li:last-child {
  border-radius : 0 5px 5px 0;
}

i {
  padding: 0px 0px;
  margin: 0px 0px 0px 0px;
}

a {
  display : block;
  text-align: center;
  line-height: 0.5;
  padding : 8px 8px; /* 10px 13px */
  font-size : 20px;   /* 26px */
  text-decoration : none;
  border-radius   : 20px;
  position        : relative;
  top   : 0;
  color : #FFF;
  transition : all .4s;
  z-index: 71;
}

span {
  display: inline-block;
  font-size: 12px;
  pointer-events: none;
  padding : 0px 0px;
  margin: 0px 0px 0px 0px;
}

/*li:hover a {*/
li:active a {
  /* TODO STYLE */
  top   : -5px; /* - arriba + abajo Desplazamiento al poner el cursor sobre el boton */
  color : black; /* color to convert skyBlue #4eacff*/
  background-color: #fff;
  box-shadow : 0 0 5px 0 rgba(255, 255, 255, 0.7);
  transition : all .1s;
  border-color : dark;
}

li a:after {
  display  : block;
  content  : "";
  position : relative;
  top  : 100%;
  left : 0%;
  border-style : solid;
  border-color : transparent;
  border-width : 5px 5px 0 5px;
  transition   : all .4s;
}

/*li:hover a:after {*/
li:active a:after {
  border-color : white transparent transparent transparent;
  transition   : all 0.7s;
}
</style>
